////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 5.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CashMaticDemoPlugin.h"

HMODULE hModuleDll;

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		hModuleDll = hModule;
		break;
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}

HRESULT DllRegisterServer(void)
	//   DLL,   REGSVR32
	//  NDemia CashMatic Demo plugin   NDemia CashMatic Demo plugin
	//	     NDemia CashMatic.
{
		HKEY hKey;
		DWORD dwDisp;
		LPCTSTR pText;

		// COM- "NDemia CashMatic Demo plugin":

		RegCreateKeyEx(HKEY_CLASSES_ROOT, TEXT("CLSID\\") TEXT(CLSID_CASHMATICDEMOPLUGIN), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
			//  : ERROR_SUCCESS,   

		pText = TEXT("NDemia CashMatic Demo plugin");
		RegSetValueEx(hKey, TEXT(""), 0, REG_SZ, reinterpret_cast<const BYTE*>(pText), (lstrlen(pText) + 1)*sizeof(*pText));
			//  : ERROR_SUCCESS,   

		RegCreateKeyEx(hKey, TEXT("InProcServer32"), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
			//  : ERROR_SUCCESS,   

		TCHAR szPath[MAX_PATH];
		GetModuleFileName(hModuleDll, szPath, MAX_PATH);
			//     ( 260 ),    

		pText = szPath;
		RegSetValueEx(hKey, TEXT(""), 0, REG_SZ, reinterpret_cast<const BYTE*>(pText), (lstrlen(pText) + 1)*sizeof(*pText));
			//  : ERROR_SUCCESS,   

		pText = TEXT("Both");
		RegSetValueEx(hKey, TEXT("ThreadingModel"), 0, REG_SZ, reinterpret_cast<const BYTE*>(pText), (lstrlen(pText) + 1)*sizeof(*pText));
			//  : ERROR_SUCCESS,   



		//   NDemia CashMatic:
		RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT("SOFTWARE\\NDemia\\CashMatic\\Plugins\\Demo"), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
			//  : ERROR_SUCCESS,   
		pText = TEXT(CLSID_CASHMATICDEMOPLUGIN);
		RegSetValueEx(hKey, TEXT("CLSID"), 0, REG_SZ, reinterpret_cast<const BYTE*>(pText), (lstrlen(pText) + 1)*sizeof(*pText));
			//  : ERROR_SUCCESS,   

		// HTML     
		LPCTSTR pStart = TEXT("\\Program Files\\NDemia\\CashMatic\\HTML\\Demo\\demo.html");

		RegCreateKeyEx(HKEY_LOCAL_MACHINE, TEXT("SOFTWARE\\NDemia\\CashMatic\\URL"), 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
			//  : ERROR_SUCCESS,   
		RegSetValueEx(hKey, TEXT("start"), 0, REG_SZ, reinterpret_cast<const BYTE*>(pStart), (lstrlen(pStart) + 1)*sizeof(*pStart));

		return S_OK;
}

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID * ppvObj) 
//   
{
	try
	{
		//MessageBox(0, TEXT("DllGetClassObject"), TEXT("CashMatic Demo plugin"), MB_OK);
		HRESULT hr;
		if(IsEqualIID(rclsid, CCashMaticDemoPlugin::ClsId))
		{
			ClassFactory *pClassFactory = new ClassFactory;
			hr = pClassFactory->QueryInterface(riid, ppvObj); 
			pClassFactory->Release(); 
		}
		else
			hr = E_NOINTERFACE;
		return hr;
	}
	catch(...)
	{
		return E_FAIL;
	}
}

