////////////////////////////////////////////////////////////
//Project: NDemia CashMatic Demo plugin. v.1.0.0
//
//	Step 1.
//
//(C)opyright NDemia 2009
////////////////////////////////////////////////////////////

#ifdef CASHMATICDEMOPLUGIN_EXPORTS
#define CASHMATICDEMOPLUGIN_API __declspec(dllexport)
#else
#define CASHMATICDEMOPLUGIN_API __declspec(dllimport)
#endif

class ICashMaticPlugin : public IDispatch
		//    NDemia CashMatic
{
	public:
		virtual void CALLBACK Init(IDispatch* pCashMatic) = 0;
};

extern IID IID_ICashMaticPlugin; //  ICashMaticPlugin (   NDemia CashMatic)

// CLSID  "CashMatic Demo plugin"
#define CLSID_CASHMATICDEMOPLUGIN "{0188E65E-D900-4056-AC46-C04678E79C06}"

class CCashMaticDemoPlugin
	: public ICashMaticPlugin
{
protected:
	LONG RefCount;
	ITypeInfo* pTypeInfo;
public:
	static const CLSID ClsId;
public:
	CCashMaticDemoPlugin();
	~CCashMaticDemoPlugin();

	//IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG STDMETHODCALLTYPE AddRef();
	virtual ULONG STDMETHODCALLTYPE Release(void);

	//IDispatch
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfoCount(unsigned int* pctinfo);
	virtual HRESULT STDMETHODCALLTYPE GetTypeInfo(unsigned int iTInfo, LCID lcid, ITypeInfo** ppTInfo);
	virtual HRESULT STDMETHODCALLTYPE GetIDsOfNames(REFIID riid, OLECHAR** rgszNames, unsigned int cNames, LCID lcid, DISPID* rgDispId);
	virtual HRESULT STDMETHODCALLTYPE Invoke(DISPID dispIdMember, REFIID riid, LCID lcid, WORD wFlags, DISPPARAMS* pDispParams, VARIANT* pVarResult, EXCEPINFO* pExcepInfo, unsigned int FAR* puArgErr);

	//ICashMaticPlugin
	virtual void CALLBACK Init(IDispatch* pCashMatic);
};

extern HMODULE hModuleDll;	//  DLL - . dllmain.cpp

class ClassFactory : public IClassFactory
		//  CCashMaticDemoPlugin
{
protected:
	LONG RefCount;

public:
	ClassFactory();

	//IUnknown
	virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, void ** ppvObject);
	virtual ULONG STDMETHODCALLTYPE AddRef();
	virtual ULONG STDMETHODCALLTYPE Release(void);

	//IClassFactory
	virtual HRESULT STDMETHODCALLTYPE CreateInstance(IUnknown * pUnkOuter, REFIID riid, void ** ppvObject);
	virtual HRESULT STDMETHODCALLTYPE LockServer(BOOL fLock);

};

